/**
 * @typedef {(string | HTMLElement | {
 *   <T extends boolean | HTMLElement[]>(options: { all: T, root?: HTMLElement, $?: HTMLElement }):
 *     T extends true ? (HTMLElement | HTMLElement[] | null) : (HTMLElement | null)
 * })} Selector
 */
/**
 * @typedef {{
 *   <T extends boolean = false>(options?: { all?: T }):
 *     T extends true ? HTMLElement[] : HTMLElement
 *   (options?: { all?: boolean }): HTMLElement[] | HTMLElement
 * }} SelectorFunction
 */
/**
 * @param {import('./context').Context} context
 * @param {Selector} [selector]
 * @returns {SelectorFunction}
 */
export function createSelectorFunction(context: import('./context').Context, selector?: Selector): SelectorFunction;
export type Selector = string | HTMLElement | (<T extends boolean | HTMLElement[]>(options: {
    all: T;
    root?: HTMLElement;
    $?: HTMLElement;
}) => T extends true ? HTMLElement | HTMLElement[] : HTMLElement);
export type SelectorFunction = {
    <T extends boolean = false>(options?: {
        all?: T;
    }): T extends true ? HTMLElement[] : HTMLElement;
    (options?: {
        all?: boolean;
    }): HTMLElement[] | HTMLElement;
};
//# sourceMappingURL=selector.d.ts.map